import type { Util_FlatType } from '@closeio/rn-common/dist/src/rn-common/src/Types';
import type { BridgeMessageDefinition, BridgeMessageShapeDefinition } from './Types';
export type RouteBridgeMessageShapeDefinition<BMSD> = BMSD extends BridgeMessageShapeDefinition<infer Payload, infer Response> ? BridgeMessageShapeDefinition<Payload, Record<string, Response>> : never;
export type RouteBridgeMessageDefinitionResponses<Messages extends BridgeMessageDefinition[]> = Util_FlatType<Messages extends [infer First, ...infer Rest] ? [
    ...First extends BridgeMessageDefinition<infer Action, infer Sendable, infer Receivable> ? [
        {
            action: Action;
        } & (Sendable extends undefined ? {} : {
            sendable: RouteBridgeMessageShapeDefinition<Sendable>;
        }) & (Receivable extends undefined ? {} : {
            receivable: Receivable;
        })
    ] : [],
    ...(Rest extends BridgeMessageDefinition[] ? RouteBridgeMessageDefinitionResponses<Rest> : [])
] : []>;
